import 'package:flutter/material.dart';
import 'package:progamification/src/controllers/leader_board.dart';
import 'package:get/get.dart';
import 'package:progamification/src/services/sas_token.service.dart';

class Progress extends StatefulWidget {
  const Progress({super.key});

  @override
  State<Progress> createState() => _ProgressState();
}

class _ProgressState extends State<Progress> {
  LeaderBoardController leaderBoardController =
      Get.find<LeaderBoardController>();

  SasTokenService sasTokenService = Get.find<SasTokenService>();
  String sasToken = "";

  @override
  initState() {
    super.initState();
    sasTokenService.getSasToken().then((value) {
      setState(() {
        sasToken = value.toString();
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        decoration: const BoxDecoration(
            color: Color.fromARGB(255, 244, 244, 244),
            border: Border(
              bottom: BorderSide(
                color: Color.fromARGB(255, 228, 228, 228),
                width: 1.0,
              ),
            )),
        padding: const EdgeInsets.only(
            left: 16.0, right: 16.0, top: 40.0, bottom: 40.0),
        child: Column(
          // direction: Axis.vertical,
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            Padding(
                padding: const EdgeInsets.only(bottom: 15.0),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: const [
                    Text(
                      "Level 0",
                      style: TextStyle(
                          fontSize: 19.0,
                          fontWeight: FontWeight.bold,
                          fontFamily: 'PlusJakartaSans-SemiBold'),
                    ),
                    Text("3405 points",
                        style: TextStyle(
                            fontSize: 18.0,
                            fontFamily: 'PlusJakartaSans-SemiBold'))
                  ],
                )),
            Container(
                height: 20,
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.circular(10.0),
                  border: Border.all(color: Colors.blue.shade200),
                ),
                child: ClipRRect(
                    borderRadius: BorderRadius.circular(10.0),
                    child: LinearProgressIndicator(
                      backgroundColor: Colors.grey.shade200,
                      color: Colors.blue.shade200,
                      value: int.parse(
                              leaderBoardController.userRewards["progress"]) /
                          100,
                      minHeight: 20,
                    )))
          ],
        ));
  }
}
